/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.terasoluna.rich.tutorial.service.blogic;

import java.util.List;
import jp.terasoluna.rich.tutorial.service.bean.ResultData;
import jp.terasoluna.rich.tutorial.service.bean.UserBean;
import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.fw.service.rich.BLogic;
import jp.terasoluna.fw.service.rich.exception.ServiceException;

/**
 * データベースアクセスのBLogicクラス
 *
 */
public class DBAccessBLogic implements BLogic<UserBean, ResultData> {
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO = null;

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private QueryDAO queryDAO = null;

    /**
     * UpdateDAOを返却する。
     *
     * @return 保持するUpdateDAO
     */
    public UpdateDAO getUpdateDAO() {
        return updateDAO;
    }

    /**
     * UpdateDAOを設定する。
     *
     * @param updateDAO UpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }

    /**
     * QueryDAOを返却する。
     *
     * @return 保持するQueryDAO
     */
    public QueryDAO getQueryDAO() {
        return queryDAO;
    }

    /**
     * QueryDAOを設定する。
     *
     * @param queryDAO QueryDAO
     */
    public void setQueryDAO(QueryDAO queryDAO) {
        this.queryDAO = queryDAO;
    }

    /**
     * 入力クラスの引数のデータを登録して検索した結果を戻す。<br>
     * １．UserBeanクラスのユーザIDでデータベースを検索し、存在するかチェックする。<br>
     * ２．UserBeanクラスのデータをデータベースに登録する。<br>
     * ３．データベースのレコードを全件取得する。<br>
     * ４．ResultDataクラスに結果を格納し、返却する。
     *
     * @param inputData 入力クラス
     * @return 結果クラス
     */
    public ResultData execute(UserBean inputData) {
        // 結果クラスの生成、結果の設定
        ResultData result = new ResultData();
        
        // 入力情報ビジネスロジックの実行
        // 返却値が、falseの場合は重複エラー。
        // trueの場合は登録処理が正常に終了。
        if (!check(inputData)) {
            // 重複エラー時の処理
            //return result;
            
            throw new ServiceException("AP.00001");
        }
        // ユーザ情報を登録する。
        updateDAO.execute("insertUser", inputData);
        
        // ユーザ情報を全件取得する。
        List<UserBean> userBeanList = queryDAO.executeForObjectList("getUserList", null);
        result.setUserBean(userBeanList);
        result.setTotalCount(Integer.valueOf(userBeanList.size()));
        return result;
    }

    /**
     * 入力されたIDが重複か否かをデータベースから取得して判定する。
     * 重複している場合は、falseを返却する。
     * 重複していない場合は、trueを返却する。
     *
     * @param inputData 入力された値を保持するJavaBean
     * @return チェック結果
     */
    private boolean check(UserBean inputData) {
        // IDからデータを検索する。
        Integer count = queryDAO.executeForObject("getUserCount", inputData,
                Integer.class);
        if (count != null && count.intValue() > 0) {
            return false;
        }
        
        // データが取得できなかった場合は、重複していないとして
        // trueを返却する。
        return true;
    }
}
